// dsc_mpe_can2l_demo.c : Defines the entry point for the console application.
//

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <sys/time.h>

static int kbhit()
{
	struct timeval timeout;
	fd_set rfds;

	timeout.tv_sec = 0;
	timeout.tv_usec = 0;

	FD_ZERO(&rfds);
	FD_SET(0, &rfds);

	if ( select(0+1, &rfds, NULL, NULL, &timeout) > 0 )
		return getchar();

	return 0;
}


#include "../CANLib/libcan.h"

#define MAX_CAN 4
int fd[MAX_CAN];

CANCONFIG canconfig;

unsigned int base_address = 0x7000;
unsigned int diobase_address = 0x340;


int main()
{
	char input_buffer[20];
	char dio_buffer[20];
	char output_buffer[20];
	char qbuf[20];
	int index=0;
	int can_port=0;
	int brate_index=0;
	int i=0,j=0;
	FILE *fp =NULL;
	FILE *fp1 = NULL;
	char txbuff[256];
	char txbuff1[256];
	unsigned char data[16];
	unsigned char rx_data[16];
	unsigned char data1[16];
	unsigned char rx_data1[16];
	unsigned int Tb_Type;
	int can_fd;
	unsigned char  msgType;
	unsigned int can_id;
	unsigned char len;
	int rtr;
	unsigned char  msgType1 =0;
	unsigned int can_id1 =0;
	unsigned char len1=0;
	int rtr1=0;
	int temp;
	int ret =0;
	int mode=0;
	CANMESSAGE Tx;
	CANMESSAGE Rx;
	int delay;
	int flag;
	
	printf ( "\nDSC_JNMM-CAN4LP-XT_DEMO Application\n" );
	

	fp1=fopen("CAN_Transmit_Log.txt","w");
	if(fp1==NULL)
	{
			perror("fopen:");
	}
	fflush(fp1);
	sprintf(txbuff1,"CANID   MSGTYPE RTR    Len  Data                         \n");
	fprintf(fp1,"%s",txbuff1);
	
	// Log for CAN_Receive 	
	fp=fopen("CAN_Receive_Log.txt","w");
	if(fp==NULL)
	{
			perror("fopen:");
	}
	fflush(fp);
	sprintf(txbuff,"CANID    MSGTYPE RTR    Len  Data                         \n");
	
	
	fprintf(fp,"%s",txbuff);

	can_fd = JNMMCANOpen(&flag);
	if(can_fd == -1)
	{
		return 0;
	}

	if(flag==isa_mode)
	{
	  	printf("\nDSC-JNMM-CAN4LP-XT-ISA Device\n");	  	
		printf ( "Enter the base address ( 0xE000,0x1000,0x2000,0x3000,0x4000,0x5000,0x6000,default 0x7000  , hit ENTER ) : " );
		fgets ( input_buffer, 20, stdin );

		if ( input_buffer[0] == '\n' )
		{
			printf("base address default with 0x7000  \n");
		}
		else
		{
			sscanf( input_buffer, "%x", &base_address );
		}
		JNMMCANBaseAddrInit(base_address);

		printf("Enter the DIObase address (0x0100,0x0140,0x0180,0x01C0,0x0200,0x0240,0x0300,default= 0x0340 , hit ENTER) : ");
		fgets(dio_buffer, 20, stdin);

		if (dio_buffer[0] == '\n')
		{
			printf("DIOBase address default with 0x0340  \n");
		}
		else
		{
			sscanf(dio_buffer, "%x", &diobase_address);
		}
		JNMMCANDIOAddrInit(diobase_address);

	}
	else
	  	printf("\nDSC-JNMM-CAN4LP-XT-PCI Device\n");

	printf ( "Enter the CAN Port number [0-CAN0,1-CAN1,2-CAN2,3-CAN3]:");
	fgets ( input_buffer, 20, stdin );
	if ( input_buffer[0] == '\n' )
	{
		can_port =i;
	}
	else
	{
		sscanf( input_buffer, "%x", &can_port );
	}
	
	do{
	printf ( "Enter the CAN Port %d for baudrate[0-1M,1-800K,2-500k,3-250K,4-125K,5-100K,6-50k,7-20K,8-10K] : ",can_port);
	fgets ( input_buffer, 20, stdin );
	if ( input_buffer[0] == '\n' )
	{
		brate_index =0;
	}
	else
	{
		sscanf( input_buffer, "%x", &brate_index );
	}
	canconfig.Can_ch = can_port;
	canconfig.BaudRate = brate_index; 
	ret = JNMMCANConfig(can_fd,  canconfig); 
	if(ret == -1)
	{
      		return 0;
	}
	printf("Enter the CAN Operation mode[0-Tx,1-RX] :");
	fgets ( input_buffer, 20, stdin );
	if ( input_buffer[0] == '\n' )
	{
		printf("MSGType with STD:0  \n");
		mode = 0;
	}
	else
	{
		sscanf( input_buffer, "%x", &mode );
	}
	
	

	if(mode==0)// Tx_mode Enabled
	{

		printf ( "Enter the CAN %d Message Type [0-STD,1-EXT] :",can_port);
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			msgType = 0;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			msgType = temp;	
		}
		printf ( "Enter the CAN %d Transmit buffer type(Hex)[0-PTB,1-STB]  : ",can_port);
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			Tb_Type = 0;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			Tb_Type = temp;	
		}
		printf ( "Enter the CAN %d MSG_ID(Hex)    : ",can_port);
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			can_id = 0x7b;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			can_id = temp;	
		}
	
		
		printf ( "Enter the RTR  [0-Disable,1-Enable] :" );
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			rtr = 0x0;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			rtr = temp;	
		}
		printf ( "Enter the Data Length (Hex) :" );
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			len = 0x8;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			len = temp;	
		}
		if(len >8)
		{
			printf("Data length is greater than 8 \n");
			return 0;
		}
		printf("CAN %d selected for Tx\n",can_port);
		//printf(" Press any Key to end the operation \n");
		i=0;
		memset(&Tx,0,sizeof(CANMESSAGE));
		Tx.Can_ch = canconfig.Can_ch;
		Tx.Tb_Type = Tb_Type;
		Tx.Msg_type =msgType;
		Tx.Msg_ID = can_id;
		Tx.Rtr    = rtr;
		Tx.Msg_len = len;
		printf ( "Enter the Tx Data (Hex) \n" );
		for(j=0;j<len;j++)
		{
			printf("Data[%d] : ",j);
			fgets ( input_buffer, 20, stdin );
			if ( input_buffer[0] == '\n' )
			{
				printf("Invalid Data");
				return 0;
			}
			else
			{
				
				sscanf( input_buffer, "%x", &(Tx.Data[j]) );
				
			}
		}
		strcat(txbuff1," ");
		sprintf(txbuff1,"  %x        %x      %x      %x    0x%x-0x%x-0x%x-0x%x-0x%x-0x%x-0x%x-0x%x    ",Tx.Msg_ID,Tx.Msg_type,Tx.Rtr,Tx.Msg_len,Tx.Data[0],Tx.Data[1],Tx.Data[2],Tx.Data[3],Tx.Data[4],Tx.Data[5],Tx.Data[6],Tx.Data[7]);
		fprintf(fp1," %s \n",txbuff1);
		ret = JNMMCANTx( can_fd,  &Tx);
		if(ret ==-1)
		printf("Error in transmit for %d \n",can_port);
		temp=0;	
		msgType=0;
		can_id=0;
		rtr=0;
		len=0;	
		
	}

	else
	{
		printf("CAN %d selected for RX\n",can_port);
		//printf(" Press any Key to end the operation \n");		
		i=0;
		while(!kbhit())
		{
			memset(&Rx,0,sizeof(CANMESSAGE));
			Rx.Can_ch = canconfig.Can_ch;
			ret = JNMMCANRx(can_fd,&Rx);
			if(ret >= 0)
			{
				if(Rx.Msg_ID !=0)
				{
					strcat(txbuff," ");			
					sprintf(txbuff,"  %x        %x      %x      %x    0x%x-0x%x-0x%x-0x%x-0x%x-0x%x-0x%x-0x%x    ",Rx.Msg_ID,Rx.Msg_type,Rx.Rtr,Rx.Msg_len,Rx.Data[0],Rx.Data[1],Rx.Data[2],Rx.Data[3],Rx.Data[4],Rx.Data[5],Rx.Data[6],Rx.Data[7]);
					fprintf(fp," %s \n",txbuff);			
					printf("CAN:%x  MSG ID(Hex):%x   MSG_TYPE:%x   RTR:%x    Len: %x\n",Rx.Can_ch,Rx.Msg_ID,Rx.Msg_type,Rx.Rtr,Rx.Msg_len);
					printf("DataReceive :");
					for(i=0;i<Rx.Msg_len;i++)
					{
					printf(" 0x%x",Rx.Data[i]);
					}
				}
			}
			
		
		}
		
			
		printf("\nCAN %d receive log is saved to CAN_Receive_Log.txt file.\n",can_port);
	}
	printf("Press enter key to repeat or 'q' to quit :");
	fgets(output_buffer,20,stdin);
	}while(output_buffer[0] !='q');
	JNMMCANClose(can_fd);
	if(fp!=NULL)	
	fclose(fp);
	if(fp1!=NULL)
	fclose(fp1);
	
	printf ( "DSC_JNMMCAN4LP-XT_DEMO Application Closed\n" );
	return 0;
}

