// JNMM4LPXTDIOFunctions.c : Defines the entry point for the console application.
//

#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <string.h>
#include <sys/select.h>
#include <termios.h>
#include <stropts.h>
#include <unistd.h>

#define READ_BYTE 1

#define WRITE_BYTE 2

void dscsleep(int ms)
{
	usleep(ms*1000);
}
#define BYTE unsigned char
static int kbhit()
{
	struct timeval timeout;
	fd_set rfds;

	timeout.tv_sec = 0;
	timeout.tv_usec = 0;

	FD_ZERO(&rfds);
	FD_SET(0, &rfds);

	if ( select(0+1, &rfds, NULL, NULL, &timeout) > 0 )
		return getchar();

	return 0;
}

void readBytePort();

void writeBytePort();

#include "../CANLib/libcan.h"

#define MAX_CAN 4
int fd[MAX_CAN];

CANCONFIG canconfig;


unsigned int base_address = 0x7000;
unsigned int diobase_address = 0x340;


char dio_buffer[20];


int main()
{
	
	int can_fd;
	char input_buffer[20];
	char dio_buffer[20];
	int intBuff = 0; // temp variables of size int
	int temp = 0; // temporary storage
	int flag;
	printf ( "\nDSCJNMMCAN4LP-XT_DEMO RW  Application \n" );


	can_fd = JNMMCANOpen(&flag);
	if(can_fd == -1)
	{
		return 0;
	}
	if(flag==isa_mode)
	{
	  	printf ( "Enter the base address ( 0xE000,0x1000,0x2000,0x3000,0x4000,0x5000,0x6000,default 0x7000  , hit ENTER ) : " );
		fgets ( input_buffer, 20, stdin );

		if ( input_buffer[0] == '\n' )
		{
			printf("base address default with 0x7000  \n");
		}
		else
		{
			sscanf( input_buffer, "%x", &base_address );
		}
		JNMMCANBaseAddrInit(base_address);

		printf("Enter the DIObase address (0x0100,0x0140,0x0180,0x01C0,0x0200,0x0240,0x0300,default= 0x0340 , hit ENTER) : ");
		fgets(dio_buffer, 20, stdin);

		if (dio_buffer[0] == '\n')
		{
			printf("DIOBase address default with 0x0340  \n");
		}
		else
		{
			sscanf(dio_buffer, "%x", &diobase_address);
		}
		JNMMCANDIOAddrInit(diobase_address);
	}
	else
	  	printf("\n DSC-JNMM-CAN4LP-XT-PCI Device\n");
	
	//		JNMMCAN Port for Read AND Write 
	
	//
	//		Guide:
	//
	//		1. Read a Byte from CAN port 
	//		2. Write a Byte to CAN port
	//		q. Quit Program
	// 		Choose these options in any order from the menu!
	//=========================================================================
	printf( "\nJNMM Read and write a byte: Main Menu \n" );

	do
	{
		intBuff = 0;
		printf (  "########################################################\n" );
		printf (  "1) Read a Byte from CAN port \n" );
		printf (  "2) Write a Byte to CAN port\n" );
		printf (  "q) Quit Program \n" );
		printf (  "########################################################\n" );
		
	fgets ( input_buffer, 20, stdin );
        sscanf ( input_buffer, "%d", &intBuff );
        if ( input_buffer[0] == 'q' )
        {
            intBuff = 'q';
        }
		switch ( intBuff )
		{

			case READ_BYTE:
				readBytePort();
				break;

			case WRITE_BYTE:
				writeBytePort();
				break;
			case 'q':
					return 0;
            		break;

				default: // invalid option selected
					printf("Please Enter valid option \r\n");
					break;
		}
	}while ( input_buffer[0] != 'q' );





	JNMMCANClose(can_fd);	
	
	
	printf ( "DSCJNMMCAN4LP-XT_DEMO RW Application Closed\n" );
	return 0;
}
//=============================================================================
// Name: readByteDIOPort()
// Desc: Read a CAN port (0-3) by receiving a byte from the selected port's  register.
// Parameters:void
// Return: void
//=============================================================================
void readBytePort()
{
	unsigned char offset;
	int port = 0;
	int input_byte = 0; 
	char input_buffer[20];
	char output_buffer[20];
        unsigned char data =0;
	

	printf ("Enter CAN port number (0-3):");
	fgets ( input_buffer, 20, stdin );
   	sscanf ( input_buffer, "%d", &port );
	
	printf ("Enter the Offset to read from the CAN port %d (HEX):  ",port);
	fgets ( output_buffer, 20, stdin );
   	sscanf ( output_buffer, "%x", &offset );

	data = JNMMCANRead ( port,offset);
		
	printf("Byte value received from port %d = 0x%x\r\n", port, data);

	
	return;

}

//=============================================================================
// Name: writeBytePort()
// Desc: Program a CAN port (0-3) by sending a byte to the selected port's
//	  register.
// Parameters: void
// Return: void
//=============================================================================
void writeBytePort()
{
	unsigned char offset;
	int port = 0;
	char input_buffer[20];
	char output_buffer[20];
	unsigned char output_byte = 0;
	unsigned char intBuff = 0;

	printf ("Enter port number (0-3):");
	fgets ( input_buffer, 20, stdin );
   	sscanf ( input_buffer, "%d", &port );

	printf ("Enter the Offset to read from the CAN port %d (HEX):  ",port);
	fgets ( output_buffer, 20, stdin );
   	sscanf ( output_buffer, "%x", &offset );
	
	printf("Enter HEX value to the CAN Port  or q to quit:");
	fgets ( input_buffer, 20, stdin );
	sscanf ( input_buffer, "%x", &intBuff );
		
	if ( input_buffer[0] == 'q' )
	{
		intBuff = 'q';
	}
	else
	{
		output_byte = (BYTE)intBuff;
		
		JNMMCANWrite(port,offset,output_byte);
		printf("The Byte value  %x is sent to port %d \n",output_byte,port);
	}
	
	return;
}


